/*  Worst Birthday Ever
 *  version 1.0, December 18th, 2011
 *
 *  Copyright (C) 2011 Jari Komppa
 *
 *  This software is provided 'as-is', without any express or implied
 *  warranty.  In no event will the authors be held liable for any damages
 *  arising from the use of this software.
 *
 *  Permission is granted to anyone to use this software for any purpose,
 *  including commercial applications, and to alter it and redistribute it
 *  freely, subject to the following restrictions:
 *
 *  1. The origin of this software must not be misrepresented; you must not
 *     claim that you wrote the original software. If you use this software
 *     in a product, an acknowledgment in the product documentation would be
 *     appreciated but is not required.
 *  2. Altered source versions must be plainly marked as such, and must not be
 *     misrepresented as being the original software.
 *  3. This notice may not be removed or altered from any source distribution.
 *
 * Jari Komppa http://iki.fi/sol/
 *
 *************************************
 * 
 * Warning - written in about 4.8 hours, a horrible mess.
 *
 */

#include "toolkit.h"

#define TITLE "Worst Birthday Ever 1.0"

// How big a tick difference is considered 'time warp', i.e. skip the time
// (to avoid physics blowing up)
#define TICK_TIMEWARP 1000
// Physics ticks per second
#define PHYSICS_FPS 100

#define USE_PERFCOUNTERS

int tex_room, tex_font, tex_dude_idle, tex_dude_use, tex_dude_walk, tex_ending;
int gKeyState = 0;
int gLastTick = 0;

ACFont fn;

void handle_key(int keysym, int down)
{
    switch(keysym)
    {
    case SDLK_ESCAPE:
        if (!down)
        {
            exit(0);
        }
        break;
    case SDLK_UP:
    case SDLK_w:
        if (down) gKeyState |= KEY_UP; else gKeyState &= ~KEY_UP;
        break;
    case SDLK_DOWN:
    case SDLK_s:
        if (down) gKeyState |= KEY_DOWN; else gKeyState &= ~KEY_DOWN;
        break;
    case SDLK_LEFT:
    case SDLK_a:
        if (down) gKeyState |= KEY_LEFT; else gKeyState &= ~KEY_LEFT;
        break;
    case SDLK_RIGHT:
    case SDLK_d:
        if (down) gKeyState |= KEY_RIGHT; else gKeyState &= ~KEY_RIGHT;
        break;
    case SDLK_RCTRL:
    case SDLK_LCTRL:
        if (down) gKeyState |= KEY_FIRE;
        break;
    }
}

void process_events()
{
    SDL_Event event;

    while (SDL_PollEvent(&event)) 
    {
        switch (event.type) 
        {
        case SDL_KEYDOWN:
            handle_key(event.key.keysym.sym, 1);
			// If a key is pressed, report it to the widgets
			gUIState.keyentered = event.key.keysym.sym;
			gUIState.keymod = event.key.keysym.mod;
			// if key is ASCII, accept it as character input
			if ((event.key.keysym.unicode & 0xFF80) == 0)
				gUIState.keychar = event.key.keysym.unicode & 0x7f;				
            break;
        case SDL_KEYUP:
            handle_key(event.key.keysym.sym, 0);
            break;
        case SDL_MOUSEMOTION:
			// update mouse position
			gUIState.mousex = (event.motion.x * (float)DESIRED_WINDOW_WIDTH) / (float)gScreenWidth;
			gUIState.mousey = (event.motion.y * (float)DESIRED_WINDOW_HEIGHT) / (float)gScreenHeight;
            break;
		case SDL_MOUSEBUTTONDOWN:
			// update button down state if left-clicking
			if (event.button.button == 1)
            {
				gUIState.mousedown = 1;
			    gUIState.mousedownx = (event.motion.x * (float)DESIRED_WINDOW_WIDTH) / (float)gScreenWidth;
			    gUIState.mousedowny = (event.motion.y * (float)DESIRED_WINDOW_HEIGHT) / (float)gScreenHeight;
            }
			if (event.button.button == 3)
            {
				gUIState.mousedown2 = 1;
			    gUIState.mousedownx2 = (event.motion.x * (float)DESIRED_WINDOW_WIDTH) / (float)gScreenWidth;
			    gUIState.mousedowny2 = (event.motion.y * (float)DESIRED_WINDOW_HEIGHT) / (float)gScreenHeight;
            }
            if (event.button.button == 4)
            {
                gUIState.scroll = +1;
            }
            if (event.button.button == 5)
            {
                gUIState.scroll = -1;
            }
			break;
		case SDL_MOUSEBUTTONUP:
			// update button down state if left-clicking
			if (event.button.button == 1)
				gUIState.mousedown = 0;
			if (event.button.button == 3)
				gUIState.mousedown2 = 0;
			break;
        case SDL_QUIT:
            SDL_Quit();
            exit(0);
            break;
        case SDL_VIDEORESIZE:
            gScreenWidth = event.resize.w;
            gScreenHeight = event.resize.h;
            initvideo(0);
            break;
        }
    }
}

struct hitregion
{
	int x, y, w, h;
};

hitregion hit[36];


int playerx = 2676;
int player_idle = 0;
int walkdir = 0;
int talktick = -1;
int talk = -1;
int idletick = -1;
int idletalk = 0;
int use = 0;
int computertalk;
int walkto = -1;
int toiletok = 0;
int sleepok = 0;
int cutscenetick = 0;
int cutscene = 10;
int phonetalk = 0;
int kitchenok = 0;

void physics_tick(int tick)
{
    int walk = 0;
	if (walkto != -1)
	{
		if (playerx/4 == walkto/4)
		{
			walkto = -1;
			use = 1;
		}
	}
	if (walkto != -1)
	{
		if (playerx < walkto) walk++;
		else walk--;
	}
	else
	{
		if (gUIState.mousex > 300) walk++;
		if (gUIState.mousex < 20) walk--;
		if (!walk)
		{
			if (gKeyState & KEY_LEFT) walk--;
			if (gKeyState & KEY_RIGHT) walk++;
		}
	}
	playerx += walk * 4;

	if (playerx < 345) playerx = 345;
	if (playerx > 3425) playerx = 3425;

	player_idle = 1;
	if (walk) player_idle = 0;
	if (walk) use = 0;

	if (walk < 0) walkdir = 1;
	if (walk > 0) walkdir = 0;

}

void ww(char * t)
{
	int x = 0;	
	while (*t)
	{
		x++;
		if (*t == '\n') x = 0;
		t++;		
		if (x > 24)
		{
			while (x && *t != ' ')
			{
				x--;
				t--;
			}
			if (*t == ' ')
			{
				*t = '\n';
				x = 0;
			}
		}
	}
}

void setwalkdir(float x)
{
	if (x < playerx) walkdir = 0; else walkdir = 1;
}

void setwalkdir(float x1, float x2)
{
	if (playerx < x1 - 160)
		walkto = x1 - 160;
	if (playerx > x2 - 160)
		walkto = x2 - 160;
	float x = (x1+x2)/2 -160;
	if (x < playerx) walkdir = 1; else walkdir = 0;

}


static void draw_screen_ingame()
{
    int tick = SDL_GetTicks();

    int i, j;    

    if (tick - gLastTick > TICK_TIMEWARP) 
        gLastTick = tick;

    if (gLastTick >= tick)
    {
        SDL_Delay(1);
        return;
    }

	if (!cutscene)
	{
		while (gLastTick < tick)
		{
			physics_tick(gLastTick);

			gLastTick += 1000 / PHYSICS_FPS;
		}
	}

    ////////////////////////////////////
    // Rendering
    ////////////////////////////////////

    glClearColor(0,0,0,1.0);
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	if (cutscene == 10)
	{
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glEnable(GL_BLEND);
		fn.drawstring("Worst Birtday Ever\n"
			"\n"
			"     A game for Ludum Dare #22 48h contest\n"
			"     made in about 4.8 hours by\n"
			"     Jari Komppa - http://iki.fi/sol/\n"
			"\n"
			"Left click = Look\n"
			"Right click = use\n"
			"ESC quits\n"
			"\n"
			"Press space to start",0,0);
		imgui_prepare();
		if (gUIState.keychar == ' ')
		{
			cutscene = 0;
			idletick = tick;
		}
		imgui_finish();

		SDL_Delay(10);
		SDL_GL_SwapBuffers();
		return;
	}

	// endgame cutscene
	if (cutscene == 2)
	{
		gLastTick = tick;
		glDisable(GL_BLEND);
		drawtexturedrect(tex_room,-playerx,-28,4096,256,0xffffffff);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);	
		drawtexturedrect(tex_dude_idle, 160-32,-18,64,256,0xffffffff, walkdir);
		char temp[256];
		strcpy(temp, "I guess nobody is coming. Might as well hit the bed. This sucks.");
		ww(temp);
		int len = strlen(temp);
		int t = (tick - cutscenetick) / 40;
		if (len > t)
			temp[t] = 0;
		quickfont_drawstring(tex_font, temp, 20,20,0xff00ffff,1,1.4);

		if (tick - cutscenetick > 8000)
		{
			cutscenetick = tick;
			cutscene++;
		}

		SDL_Delay(10);
		SDL_GL_SwapBuffers();
		return;
	}

	if (cutscene == 3)
	{
		gLastTick = tick;
		if (tick - cutscenetick > 3000)
		{
			cutscene++;
			cutscenetick = tick;
			talktick = tick;
		}

		if (tick - cutscenetick > 1000)
			quickfont_drawstring(tex_font, "Outside..", 40,80,0xffffffff,1,2.8);

	    SDL_Delay(10);
		SDL_GL_SwapBuffers();
		return;
	}

	if (cutscene == 4)
	{
		gLastTick = tick;
		glDisable(GL_BLEND);
		drawtexturedrect(tex_ending,0,-28,512,256,0xffffffff);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);	
		char temp[256];
		strcpy(temp, "..He doesn't answer the doorbell.. \n..His phone was busy earlier.. \n..Maybe he went out?..");
		ww(temp);
		int len = strlen(temp);
		int t = (tick - cutscenetick) / 40;
		if (len > t)
			temp[t] = 0;
		quickfont_drawstring(tex_font, temp, 20,20,0xffff00ff,1,1.4);

		if (tick - cutscenetick > 12000)
		{
			cutscenetick = tick;
			cutscene++;
		}

		SDL_Delay(10);
		SDL_GL_SwapBuffers();
		return;
	}

	if (cutscene == 5)
	{
		gLastTick = tick;

		if (tick - cutscenetick > 1000)
			quickfont_drawstring(tex_font, "The end", 80,80,0xffffffff,1,2.8);

	    SDL_Delay(10);
		SDL_GL_SwapBuffers();
		return;
	}

	if (cutscene)
	{
		gLastTick = tick;
		if (tick - cutscenetick > 3000)
		{
			cutscene = 0;
			talktick = tick;
		}

		if (tick - cutscenetick > 1000)
			quickfont_drawstring(tex_font, "Later..", 100,80,0xffffffff,1,2.8);

	    SDL_Delay(10);
		SDL_GL_SwapBuffers();
		return;
	}

    ////////////////////////////////////
    // testcode
    ////////////////////////////////////

	glDisable(GL_BLEND);
	drawtexturedrect(tex_room,-playerx,-28,4096,256,0xffffffff);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);	
	if (player_idle)
	{
		if (use)
			drawtexturedrect(tex_dude_use, 160-32,-18,64,256,0xffffffff, walkdir);
		else
			drawtexturedrect(tex_dude_idle, 160-32,-18,64,256,0xffffffff, walkdir);
	}
	else
	{
		if ((tick >> 3) & 1)
		{
			drawtexturedrect(tex_dude_walk, 160-32,-18,64,256,0xffffffff, walkdir);
		}
		else
		{
			drawtexturedrect(tex_dude_idle, 160-32,-18,64,256,0xffffffff, walkdir);
		}
	}

	if (gUIState.mousedown2)
	{
		float my = gUIState.mousedowny2 + 28;
		float mx = gUIState.mousedownx2 + playerx;
		for (i = 0; i < 36; i++)
		{
			if (rect_rect_collide(mx,my,mx+1,my+1,
                      hit[i].x, hit[i].y, hit[i].x+hit[i].w, hit[i].y+hit[i].h))
			{

				switch(i)
				{
				case 30:
				case 31:
				case 32:
				case 29:
				case 33:
				case 13:
					// plant -> doesn't need water
				case 21:
					// cake, doesn't want to touch it
				case 6:
					// desk
				case 3:
					// closet
				case 34:
					// front door, nobody there
					talktick = tick;
					talk = 100+i;
					idletick = -1;
					break;
				case 15:
					// window, doesn't open
				case 7:
					// invitation, read
					setwalkdir(hit[i].x,hit[i].x+hit[i].w);
					use = 1;
					talktick = tick;
					talk = 100+i;
					idletick = -1;
					break;
				case 17:
					// punch, -> toiletok
					setwalkdir(hit[i].x,hit[i].x+hit[i].w);
					use = 1;
					talktick = tick;
					talk = 100+i;
					idletick = -1;
					if (toiletok == 0)
						toiletok = 1;
					break;
				case 10:
					// toilet -> sleepok
					if (toiletok != 1)
					{
						talktick = tick;
						talk = 100 + i;
						idletick = -1;
					}
					else
					{
						if (kitchenok == 0)
							kitchenok = 1;
						cutscene = 1;
						cutscenetick = tick;
						toiletok = -1;
						sleepok++;
						talk = 300;
						talktick = tick;
						idletick = -1;
						return;
					}
					break;

				case 25:
					// phone -> kitchenok
					if (talk == -1)
					{
						use = 1;
						setwalkdir(hit[i].x,hit[i].x+hit[i].w);
						talktick = tick;
						talk = 500+phonetalk;
						if (kitchenok == 0)
						{
							kitchenok = 1;
							sleepok++;
						}
						phonetalk++;
						if (phonetalk > 14) phonetalk = 0;
						idletick = -1;
					}
					break;
				case 8:
					// computer, can't do anything without net
					if (talk == -1)
					{
						use = 1;
						setwalkdir(hit[i].x,hit[i].x+hit[i].w);
						talktick = tick;
						talk = 200+computertalk;
						computertalk++;
						if (computertalk > 4) computertalk = 0;
						idletick = -1;
					}
					break;
				case 1:
					// bed -> gameover
					if (sleepok < 2)
					{
						talktick = tick;
						talk = 100 + i;
						idletick = -1;
					}
					else
					{
						cutscene = 2;
						cutscenetick = tick;
					}
					break;
				case 16:					
					// kitchen -> sleepok
					if (kitchenok == 0)
					{
						talktick = tick;
						talk = 100 + i;
						idletick = -1;
					}
					else
					if (kitchenok == -1)
					{
						talktick = tick;
						talk = 2000;
						idletick = -1;
					}
					else
					{
						cutscene = 1;
						cutscenetick = tick;
						kitchenok = -1;
						sleepok++;
						talk = 301;
						talktick = tick;
						idletick = -1;
						return;
					}
					break;

				default:
					talktick = tick;
					talk = 100;
					idletick = -1;
					break;
				}
				gUIState.mousedown2 = 0;
/*
					talktick = tick;
					talk = 100+i;
					idletick = -1;
*/
			}
		}
	}
	else
	if (gUIState.mousedown)
	{
		float my = gUIState.mousedowny + 28;
		float mx = gUIState.mousedownx + playerx;
		for (i = 0; i < 36; i++)
		{
			if (rect_rect_collide(mx,my,mx+1,my+1,
                      hit[i].x, hit[i].y, hit[i].x+hit[i].w, hit[i].y+hit[i].h))
			{
				talktick = tick;
				talk = i;
				idletick = -1;
			}
		}
	}

	if (idletick != -1 && (tick - idletick) > 10000)
	{
		idletick = -1;
		talk = 1000 + idletalk;
		talktick = tick;
		idletalk++;
		if (idletalk > 10)
		{
			idletick = -1;
			talk = -1;
		}

	}

	if (talk >= 0)
	{
		if (tick - talktick > 3000)
		{
			talk = -1;
			idletick = tick;
			use = 0;
		}
		else
		{
			char *data = "Where the heck is everybody?";
			char temp[1024];
			strcpy(temp, data);

			switch (talk)
			{
			case 500:
				strcpy(temp, "I'll call pekuja                ..                      ..                \nno answer.");
				break;
			case 501:
				strcpy(temp, "I'll call quin                ..                      ..                \nno answer.");
				break;
			case 502:
				strcpy(temp, "I'll call fydo                ..                      ..                \nno answer.");
				break;
			case 503:
				strcpy(temp, "I'll call PoV                ..                      ..                \nno answer.");
				break;
			case 504:
				strcpy(temp, "I'll call Benn                ..                      ..                \nno answer.");
				break;
			case 505:
				strcpy(temp, "I'll call bluescrn                ..                      ..                \nno answer.");
				break;
			case 506:
				strcpy(temp, "I'll call tonic                ..                      ..                \nno answer.");
				break;
			case 507:
				strcpy(temp, "I'll call Fiona                ..                      ..                \nno answer.");
				break;
			case 508:
				strcpy(temp, "I'll call s0s                ..                      ..                \nno answer.");
				break;
			case 509:
				strcpy(temp, "I'll call Keeyai                ..                      ..                \nno answer.");
				break;
			case 510:
				strcpy(temp, "I'll call iFire                ..                      ..                \nno answer.");
				break;
			case 511:
				strcpy(temp, "I'll call X-0ut                ..                      ..                \nno answer.");
				break;
			case 512:
				strcpy(temp, "I'll call BlackBird                ..                      ..                \nno answer.");
				break;
			case 513:
				strcpy(temp, "I'll call madgarden                ..                      ..                \nno answer.");
				break;
			case 514:
				strcpy(temp, "I'll call philhassey                ..                      ..                \nno answer.");
				break;
			case 300:
				strcpy(temp, "I think I've peed enough to last the rest of the game now.");
				break;
			case 301:
				strcpy(temp, "The kitchen is sparkling clean now. And still no guests.");
				break;
			case 200:
				strcpy(temp, "No net, no IRC.");
				break;
			case 201:
				strcpy(temp, "No net, no spotify.");
				break;
			case 202:
				strcpy(temp, "No net, no games. DRM sucks.");
				break;
			case 203:
				strcpy(temp, "No net, no kitty pictures.");
				break;
			case 204:
				strcpy(temp, "No net, no skype.");
				break;
			case 101:
				if (sleepok == 0)
					strcpy(temp, "I don't feel tired enough. And the party hasn't started.");
				else
					strcpy(temp, "I don't feel tired enough. And the guests might still arrive.");
				break;
			case 100:
				strcpy(temp, "I don't need to use that.");
				break;
			case 110:
				// toilet, notok
				strcpy(temp, "I don't need to go to the toilet - I haven't drunk much..");
				break;
			case 117:
				// punch
				strcpy(temp, "A little sip or two can't hurt..");
				break;

			case 121:
				// cake, doesn't want to touch it
				strcpy(temp, "I don't want to touch the cake without any guests here. It's tempting, though.");
				break;
			case 113:
				// plant -> doesn't need water
				strcpy(temp, "It doesn't need more water. I took care of it earlier.");
				break;
			case 115:
				// window, doesn't open
				strcpy(temp, "It doesn't open. It's good we have central air. And it's raining, too.");
				break;
			case 107:
				// invitation, read
				strcpy(temp, "'You are hereby invited to the best birthday party ever - mine!!'");
				break;
			case 134:
				// front door, nobody there
				strcpy(temp, "Nobody has rung the bell, so there's no need to open the door.");
				break;
			case 106:
				// desk
				strcpy(temp, "I said, no work today.");
				break;
			case 103:
				strcpy(temp, "I don't need to change.\nEver.");
				break;

			case 130:
			case 131:
			case 132:
			case 129:
			case 133:
				strcpy(temp, "I don't need it right now.");
				break;
			case 116:
				strcpy(temp, "Yes, the kitchen is a mess, but guests might arrive any moment now.");
				break;
			case 2000:
				strcpy(temp, "I'm done with the kitchen.");
				break;

			case 1000:
				strcpy(temp, "The guests should be arriving soon..");
				break;
			case 1001:
				strcpy(temp, "Maybe the traffic is bad. They'll come soon.");
				break;
			case 1002:
				strcpy(temp, "Maybe I should call and check if they're ok..");
				break;
			case 1003:
				strcpy(temp, "Where the heck is everybody?");
				break;
			case 1004:
				strcpy(temp, "If my internet worked, I could ask on IRC or something..");
				break;
			case 1005:
				strcpy(temp, "I should have included RSVP in the invitations..");
				break;
			case 1006:
				strcpy(temp, "*sigh*");
				break;
			case 1007:
				strcpy(temp, "Have they all become sick at the same time?");
				break;
			case 1008:
				strcpy(temp, "I didn't know I'm THIS unpopular..");
				break;
			case 1009:
				strcpy(temp, "*sigh*");
				break;


			case 0:
			case 35:
				strcpy(temp, "Outer wall of the house.");
				break;
			case 1:
				if (sleepok == 0)
					strcpy(temp, "My bed. No time to sleep, the party starts soon!");
				else
				if (sleepok > 1)
					strcpy(temp, "My bed. It looks rather inviting.");
				else
					strcpy(temp, "My bed.");
				break;

			case 2:
				strcpy(temp, "It's the bedroom lamp.");
				break;

			case 3:
				strcpy(temp, "Closet. I don't need to change.\nEver.");
				break;

			case 10:
				strcpy(temp, "That's the toilet.");
				break;
			case 13:
				strcpy(temp, "My pet plant. Yes, I've watered it.");
				break;
			case 14:
				strcpy(temp, "My rug. I like my rug.");
				break;
			case 15:
				strcpy(temp, "It's raining outside.");
				break;
			case 16:
				if (kitchenok == 0)
					strcpy(temp, "The kitchen is a mess. I'll clean up tomorrow.");
				if (kitchenok == 1)
					strcpy(temp, "The kitchen is a mess. Might as well clean it to pass time.");
				if (kitchenok == -1)
					strcpy(temp, "The kitchen is sparkly clean now. Still, no guests.");
				break;
			case 18:
				strcpy(temp, "Everything you need for a party..");
				break;
			case 17:
				strcpy(temp, "Slightly spiked punch..");
				break;
			case 19:
				strcpy(temp, "Plates and mugs..");
				break;
			case 20:
				strcpy(temp, "Some wine..");
				break;
			case 21:
				strcpy(temp, "Cake! No lie!");
				break;
			case 22:
				strcpy(temp, "Chandelier has seen better days.. or well, it hasn't.");
				break;
			case 23:
				strcpy(temp, "A bit tacky, I agree.");
				break;
			case 24:
				strcpy(temp, "My almost genuine persian rug..");
				break;
			case 25:
				strcpy(temp, "Believe or not, this is my phone.");
				break;
			case 26:
				strcpy(temp, "It holds the telephone off the floor.");
				break;
			case 30:
				strcpy(temp, "My hat.");
				break;
			case 31:
				strcpy(temp, "My coat.");
				break;
			case 32:
				strcpy(temp, "My shoes.");
				break;
			case 29:
				strcpy(temp, "Clothes rack.");
				break;
			case 33:
				strcpy(temp, "My umbrella.");
				break;
			case 34:
				strcpy(temp, "Front door              ..               \nAny moment now..");
				break;

			case 27:
			case 28:
			case 11:
			case 12:
			case 5:
			case 4:
				strcpy(temp, "Divider wall. What will they think of next?");
				break;

			case 6:
				strcpy(temp, "That's my desk. No work today. Yay.");
				break;
			case 7:
				strcpy(temp, "Leftover invitations. I sent a lot.");
				break;
			case 8:
				strcpy(temp, "Internet is down. Again. My ISP sucks.");
				break;
			case 9:
				strcpy(temp, "No, it's a lamp, not a noose.");
				break;

			default:
				sprintf(temp, "undefined %d",talk);
			}
			ww(temp);
			int len = strlen(temp);
			int t = (tick - talktick) / 20;
			if (len > t)
				temp[t] = 0;
			quickfont_drawstring(tex_font, temp, 20,20,0xff00ffff,1,1.4);
		}
			
	}
	/*
	char temp[256];
	sprintf(temp, "%d", playerx);
	SDL_WM_SetCaption(temp,NULL);
	*/
	// Draw "mouse cursor"
	drawrect(gUIState.mousex-9,gUIState.mousey-2,6,4,0xff000000);
	drawrect(gUIState.mousex+3,gUIState.mousey-2,6,4,0xff000000);
	drawrect(gUIState.mousex-2,gUIState.mousey-9,4,6,0xff000000);
	drawrect(gUIState.mousex-2,gUIState.mousey+3,4,6,0xff000000);

	drawrect(gUIState.mousex-8,gUIState.mousey-1,4,2,0xffffffff);
	drawrect(gUIState.mousex+4,gUIState.mousey-1,4,2,0xffffffff);
	drawrect(gUIState.mousex-1,gUIState.mousey-8,2,4,0xffffffff);
	drawrect(gUIState.mousex-1,gUIState.mousey+4,2,4,0xffffffff);

    SDL_Delay(10);
	SDL_GL_SwapBuffers();
}



void draw_screen()
{
    draw_screen_ingame();
}

void process()
{
	int x, y, n;
	unsigned int *data = (unsigned int *)stbi_load("data/hitregions.png", &x, &y, &n, 4);

	int i, j;
	int count = 0;
	for (i = 0; i < x; i++)
	{
		for (j = 0; j < y; j++)
		{
			if (data[j*x+i] & 0xff)
			{
				int h,w;
				h = 0;
				w = 0;
				while (data[(j+0)*x+i+w] & 0xff) w++;
				while (data[(j+h)*x+i+0] & 0xff) h++;
				int a,b;
				for (a = 0; a < h; a++)
					for (b = 0; b < w; b++)
						data[(j+a)*x+i+b] = 0;
				hit[count].x = i;
				hit[count].y = j;
				hit[count].w = w;
				hit[count].h = h;
				count++;
			}
		}
	}
}


int main (int argc, char** args)
{
    gVisualRand.init_genrand(0xc0cac01a);

    if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_NOPARACHUTE) < 0) 
    {
        fprintf(stderr, "Video initialization failed: %s\n", SDL_GetError());
        SDL_Quit();
        exit(0);
    }

    initvideo(argc);

    tex_font = load_texture("data/fona.png");
	tex_room = load_texture("data/room.png");
	tex_dude_idle = load_texture("data/dude_side_idle.png");
	tex_dude_use = load_texture("data/dude_side_use.png");
	tex_dude_walk = load_texture("data/dude_side_walk.png");
	tex_ending = load_texture("data/ending.png");

	process();

	// For imgui - Enable keyboard repeat to make sliders more tolerable
	SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY, SDL_DEFAULT_REPEAT_INTERVAL);
	// For imgui - Enable keyboard UNICODE processing for the text field.
	SDL_EnableUNICODE(1);

    // load a font..
    fn.load("data/vera12.fnt");
    
    // set window title
    SDL_WM_SetCaption(TITLE " - http://iki.fi/sol/", NULL);

    // hide cursor
    SDL_ShowCursor(0);

//	SDL_SetCursor(load_cursor("cursor_scissors.png",0,0));
    
	idletick = SDL_GetTicks();

    while (1) 
    {
        process_events();
        draw_screen();
    }

    return 0;
}
